## glshim 0.0.20140825

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(glshim)

if(NOT DEFINED CMAKE_RUNTIME_OUTPUT_DIRECTORY)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif()

if(NOT DEFINED CMAKE_LIBRARY_OUTPUT_DIRECTORY)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
endif()

if(NOT DEFINED CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
endif()

link_directories(${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

# Raspberry PI
if(BCMHOST)
    include_directories(/opt/vc/include /opt/vc/include/interface/vcos/pthreads /opt/vc/include/interface/vmcs_host/linux)
    link_directories(/opt/vc/lib)
    add_definitions(-DBCMHOST -D_GNU_SOURCE)
endif()

link_directories(${CMAKE_BINARY_DIR}/lib)
add_definitions(-O2)
include(flags.cmake)

include_directories(include)
add_subdirectory(src)

=== src/CMakeLists.txt ===
include_directories(util)

file(GLOB_RECURSE GL_SOURCES gl/*.c gl/*.cpp)
file(GLOB UTIL_SOURCES util/*.c)
set(GL_SOURCES ${GL_SOURCES} ${UTIL_SOURCES})

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    include_directories(glx)
    aux_source_directory(glx GLX_SOURCES)
    list(APPEND GL_SOURCES ${GLX_SOURCES})
else()
    message(STATUS "Not on Linux: building without GLX support.")
endif()

add_library(GL SHARED ${GL_SOURCES})
set_target_properties(GL PROPERTIES VERSION 1 SOVERSION 1.2.0)
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    target_link_libraries(GL EGL X11)
endif()

add_library(GL_static STATIC EXCLUDE_FROM_ALL ${GL_SOURCES})
set_target_properties(GL_static PROPERTIES OUTPUT_NAME GL)
add_library(GL_shared SHARED ${GL_SOURCES})
set_target_properties(GL_shared PROPERTIES OUTPUT_NAME GLshim)

add_library(GL2 SHARED EXCLUDE_FROM_ALL ${GL_SOURCES})
set_target_properties(GL2 PROPERTIES COMPILE_FLAGS -DUSE_ES2)

if(BCMHOST)
    set(PI_LIBS bcm_host vcos pthread)
    target_link_libraries(GL ${PI_LIBS} GLESv1_CM)
    target_link_libraries(GL2 ${PI_LIBS} GLESv2)
endif()

aux_source_directory(preload PRELOAD_SOURCES)
add_library(preload SHARED EXCLUDE_FROM_ALL ${PRELOAD_SOURCES})
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    target_link_libraries(preload X11)
endif()

add_subdirectory(proxy)

INSTALL(TARGETS GL
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
)

=== test/requirements.txt ===
Jinja2
blessings

=== debian/changelog ===
glshim (0.0.20140825-0~rzr20140830) unstable; urgency=medium

  * wip: http://rzr.online.fr/q/snapshot#glshim

 -- Philippe Coval <rzr@gna.org>  Sat, 30 Aug 2014 22:03:36 +0200

glshim (0.0.20140830-0~rzr) unstable; urgency=medium

  * WIP: http://rzr.online.fr/q/snapshot#glshim

 -- Philippe Coval <rzr@gna.org>  Sat, 30 Aug 2014 22:03:36 +0200

glshim (0.0.0-0~rzr1) harmattan; urgency=low

  * Non-maintainer upload.
  * http://rzr.online.fr/q/opengles

 -- Philippe Coval <rzr@gna.org>  Thu, 05 Sep 2013 07:16:27 +0200

libglshim (0.1-maemo3) unstable; urgency=low

  * Can be used with freeglut3 / freeglut3-dev
   -libglshim provides libgl1
   -libglsim-dev provies libgl-dev

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Tue, 06 Aug 2013 13:23:31 +0200

libglshim (0.1-maemo2) unstable; urgency=low
	
  *Add: dh_makeshlibs

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Mon, 05 Aug 2013 21:34:31 +0200

libglshim (0.1-maemo1) unstable; urgency=low
	
  * Initial version

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Sun, 04 Aug 2013 15:47:31 +0200

=== debian/control ===
Source: glshim
Section: libs
Priority: optional
Maintainer: Philippe Coval <rzr@gna.rg>
XSBC-Original-Maintainer-Fremantle: Aapo Rantalainen <aapo.rantalainen@gmail.com>
Build-Depends: debhelper (>> 5.0.0), cmake,
  libx11-dev,
  libgles1-sgx-img-dev [armel arm], libgles2-sgx-img-dev [armel arm],
  libsdl1.2-dev
Standards-Version: 3.7.2
XSBC-Bugtracker: mailto:aapo.rantalainen@gmail.com

Package: libglshim0
Architecture: any
Replaces: libgl1
Provides: libgl1
Conflicts: libgl1
Depends: ${shlibs:Depends}
Description: GL to GLES

Package: libglshim-dev
Architecture: any
Depends: ${shlibs:Depends}, libglshim0
Replaces: libgl-dev
Provides: libgl-dev
Conflicts: libgl-dev
Description: GL to GLES


Package: glshim-snapshot
Architecture: all
Section: utils
Depends: glshim (= ${source:Version}), ${misc:Depends}
Suggests: rzr
Priority: extra
Description: unreleased snapshot version
 TODO: Remove on issue and upgrade glshim
 http://rzr.online.fr/q/snapshot#glshim Feedback welcome

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess. 

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
package?=glshim
build_dir?=$(shell pwd)/build/
# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CPPFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CPPFLAGS += -O0
else
	CPPFLAGS += -O3
endif

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CPPFLAGS += -g -O0 -DDEBUG
else
	CPPFLAGS += -DNDEBUG
endif



config.status: configure
	dh_testdir
	# Add here commands to configure the package.

configure:

build: build-stamp
build-stamp: config.status
	dh_testdir

	# Add here commands to compile the package.
ifneq (,$(findstring arm-linux,$(DEB_BUILD_GNU_TYPE)))
	mkdir -p "${build_dir}"
	cd "${build_dir}" \
	&& cmake .. \
	  -DCMAKE_RUNTIME_OUTPUT_DIRECTORY="" \
	  -DCMAKE_LIBRARY_OUTPUT_DIRECTORY="" \
	  -DCMAKE_ARCHIVE_OUTPUT_DIRECTORY="" \
	&& cmake --build . --target GL
endif

	touch build-stamp

clean: config.status
	dh_testdir
	dh_testroot
	rm -f build-stamp

	# Add here commands to clean up after the build process.
	rm -rf build debian/*${package}*

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/<packagename>
	#$(MAKE) DESTDIR=`pwd`/debian/`dh_listpackages` install
	#!/bin/sh
	CURDIR=$1

ifneq (,$(findstring arm-linux,$(DEB_BUILD_GNU_TYPE)))
	mkdir -p ${CURDIR}/debian/libglshim-dev/usr/include/
	cp -r include/GL ${CURDIR}/debian/libglshim-dev/usr/include/

	mkdir -p ${CURDIR}/debian/libglshim/usr/lib
	cp ${CURDIR}/build/src/libGL.so.1  ${CURDIR}/debian/libglshim/usr/lib/
	ln -s libGL.so.1 ${CURDIR}/debian/libglshim/usr/lib/libGL.so
endif


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
#	dh_installchangelogs
#	dh_installdocs
#	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installcatalogs
#	dh_installpam
	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
#	dh_installwm
#	dh_installudev
#	dh_undocumented
#	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
